#include <bits/stdc++.h>

using namespace std;
#define MAXN 500005
stack <int> sol;

int main()
{
    ios_base::sync_with_stdio(false);
    int n,k;
    cin >> n >> k;
    int tr=0;
    for(int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        if(!sol.size())
        {
            //sol.push_back(x);
            sol.push(x);
            continue;
        }
        while(sol.size() > 0 && sol.top()>x && tr < k)
        {
            tr++;
            sol.pop();
        }
        sol.push(x);
    }
    vector <int> ans;
    while(!sol.empty())
    {
        ans.push_back(sol.top());
        sol.pop();
    }
    for(int i = ans.size()-1; i >= 0; i--)
    {
        cout << ans[i] << " ";
    }
    return 0;
}